//+---------------------------------------------------------------------+
//|                                                   Blessing 3 v3.6.5 |
//|                                                      March 17, 2010 |
//|                                 Copyright  2007-2010, MQLCoder.com |
//|             Improved Strategy and Safety by LRon / jta@jtatoday.com |
//|            Main Strategy by FiFtHeLeMeNt / fifthelement80@gmail.com |
//|            Bollinger Band and Stochastic Indicator addition by Jepm |
//|    Min Lot check condition/Improved MM math/CCI addition by Beckham |
//|              Sync TP and Postive ProfitPotential Fix by Robotofdawn |
//|   Debugging/Recoding/Streamlining and Order Check Functions by d4v3 |
//|     In no event will authors be liable for any damages whatsoever.  |
//|                         Use at your own risk.                       |
//+---------------------------------------------------------------------+

#property copyright "Copyright  2007-2010, J Talon LLC/FiFtHeLeMeNt"
#property link      "http://www.jtatoday.com"
#include    <stdlib.mqh>
#include    <stderror.mqh>
#include    <WinUser32.mqh>

extern string   TradeComment        = "Blessing";

extern bool     ShutDown            = false;    // Setting this to true will stop the EA trading after any open trades have been closed

extern int      EANumber            = 1;        // Enter a unique number to identify this EA

extern double   StopTradePercent    = 10;       // percent of account balance lost before trading stops

extern bool     IBFXmicro           = false;    // set to true for IBFX micro "penny a pip"

extern bool     UseMM               = true;     // Money Management

extern double   LAF                 = 0.5;      // Adjusts MM base lot for large accounts

extern double   lot                 = 0.01;     // Starting lots if Money Management is off

extern double   Portion             = 1.0;      // Portion of account you want to trade on this pair

extern double   MaxDDPercent        = 50;       // Percent of portion for max drawdown level.

extern double   Multiplier          = 1.4;      // Multiplier on each level

extern bool     LinearLotSize       = false;    // Use linear increment of lots, if this is true, ignores multiplier

extern int      MaxTrades           = 15;       // Maximum number of trades to place (stops placing orders when reaches MaxTrades)

extern int      BreakEvenTrade      = 12;       // Close All level , when reaches this level, doesn't wait for TP to be hit

extern bool     MaximizeProfit      = false;    // Turns on TP move and Profit Trailing Stop Feature

extern double   ProfitSet           = 70;       // Locks in Profit at this percent of Total Profit Potential

extern int      MoveTP              = 30;       // Moves TP this amount in pips

extern int      TotalMoves          = 2;        // Number of times you want TP to move before stopping movement

extern bool     BollingerStochEntry = false;    // if false, uses simple MA for entry

extern bool     CCIEntry            = false;    // Confirms MA trend and updates it if necessary

extern bool     UsePowerOutSL       = false;    // Transmits a SL in case of internet loss

extern bool     AutoCal             = false;    // Auto calculation of TakeProfit and Grid size;

extern double   GAF                 = 1.0;      // Widens/Squishes Grid on increments/decrements of .1

extern int      EntryDelay          = 2400;     // Time Grid in seconds , to avoid opening of lots of levels in fast market

extern int      EntryOffset         = 5;        // In pips, used in conjunction with logic to offset first trade entry

extern string   Advancedset         = "Advanced Settings Change sparingly";

extern string   LabelUE             = "Set to 'true' if you would like warnings sent by Email";
extern bool     UseEmail            = false;
extern string   LabelEDD            = "At what DD% would you like Email warnings (Max: 49, Disable: 0)?";
extern int      EmailDD1            = 25;
extern int      EmailDD2            = 35;
extern int      EmailDD3            = 45;
extern string   LabelEH             = "Number of hours before DD timer resets";
extern double   EmailHours          = 1;        // Minimum number of hours between emails

extern int      MAPeriod            = 100;      // Period of MA (H4 = 100, H1 = 400)
extern double   MADistance          = 10;        // Distance from MA to be treated as Ranging Market

extern int      BollPeriod          = 10;       // Period for Bollinger
extern double   BollDistance        = 10;       // Up/Down spread
extern double   BollDeviation       = 2.0;      // Standard deviation multiplier for channel
extern int      BuySellStochZone    = 20;       // Determines Overbought and Oversold Zones
extern int      KPeriod             = 10;       // Stochastic parameters
extern int      DPeriod             = 2;        // Stochastic parameters
extern int      Slowing             = 2;        // Stochastic parameters

extern string   SetCountArray       = "4,4";   // Specifies number of open trades at each set level (separated by a comma) 
extern string   GridSetArray        = "25,50,100"; // Specifies number of pips away to issue limit order (separated by a comma)
extern string   TP_SetArray         = "50,100,200"; // Take profit for each level (separated by a comma)


extern int      ForceMarketCond     = 3;        // Market condition 0=uptrend 1=downtrend 2=range 3=off

extern double   Level               = 7;        // Largest Assumed Basket size.  Lower number = higher start lots

extern double   slip                = 99;       // Adjusts opening and closing orders by "slipping" this amount

extern bool     EmergencyCloseAll   = false;    // Setting this to true will close all open orders immediately

extern string   DisplayControl      = "Used to Adjust Overlay";
extern bool     displayOverlay      = true;     // Turns the display on and off
extern bool     displayLogo         = true;     // Turns off copyright and icon
extern bool     displayCCI          = true;     // Turns off the CCI display
extern bool     displayLines        = true;     // Show BE, TP and TS lines
extern int      displayXcord        = 100;      // Moves display left and right
extern int      displayYcord        = 22;       // Moves display up and down
extern int      displayCCIxCord     = 10;       // Moves CCI display left and right 
extern int      displayFontSize     = 9;        // Changes size of display characters
extern int      displaySpacing      = 14;       // Changes space between lines
extern color    displayColor        = DeepSkyBlue; // default color of display characters


extern bool     debug_msgs          = false;

//+-----------------------------------------------------------------+
//| Internal Parameters Set                                         |
//+-----------------------------------------------------------------+

bool        ca                  = false;
int         magic               = 0;
int         BrokerDecimal       = 1;
int         count;
double      counter;
int         moves;
double      MaxDD;
double      ProfitSL;
int         Accounttype         = 1;
double      pipvalue;
double      StopTradeBalance;
double      InitialAB;
bool        Testing             = false;
bool        Visual              = false;
double      BaseTarget;
bool        AllowTrading;
bool        EmergencyWarning;
double      MaxDDPer;
int         Error;
int         Set1Level, Set2Level, Set3Level, Set4Level;
int         EmailCount;
string      TF;
datetime    EmailSent;
int         GridArray[][2];
int         GridSet1, GridSet2, GridSet3, GridSet4, GridSet5;
int         TP_Set1, TP_Set2, TP_Set3, TP_Set4, TP_Set5;
double      MinLotSize, MinLotStep, LotDecimal;
bool        DelLot1, DelLot2;

//+-----------------------------------------------------------------+
//| expert initialization function                                  |
//+-----------------------------------------------------------------+

int init(){
		GenerateMagicNumber();

		if (Digits==3 || Digits==5){
				BrokerDecimal = 10;
				MoveTP *= 10;
				EntryOffset *= 10;
				slip *=10;
				MADistance *= 10;
		}

		if (IBFXmicro) Accounttype = 10;
		InitialAB=AccountBalance();
		StopTradeBalance=InitialAB - InitialAB*(StopTradePercent/100);

		Testing=IsTesting();
		Visual=IsVisualMode();

		LabelCreate();

		AllowTrading = true;
		EmergencyWarning = EmergencyCloseAll;

		if (ForceMarketCond < 0 || ForceMarketCond > 3) ForceMarketCond = 3;

		MinLotSize = MathMax(lot, MarketInfo(Symbol(), MODE_MINLOT));
      MinLotStep = MarketInfo(Symbol(), MODE_LOTSTEP);
      LotDecimal = MathCeil(MathLog(1 / MinLotStep) /  MathExp(1));
      if (debug_msgs) Print("Lot Decimal: " + LotDecimal);

		Comment("Waiting for next tick .....");

		//+-----------------------------------------------------------------+
		//| Set Grid and TP array                                           |
		//+-----------------------------------------------------------------+

		if (!AutoCal){
				ArrayResize(GridArray, MaxTrades);
				int SetTemp, GridTemp, TPTemp, Index, LevelTemp;
				while (Index < MaxTrades){
						if (StringFind(SetCountArray, ",") == -1 && Index == 0){
								Error = 1;
								break;
						}
						else SetTemp = StrToInteger(StringSubstr(SetCountArray, 0, StringFind(SetCountArray, ",")));
						if (SetTemp > 0){
								SetCountArray = StringSubstr(SetCountArray, StringFind(SetCountArray, ",") + 1);
								GridTemp = StrToInteger(StringSubstr(GridSetArray, 0, StringFind(GridSetArray, ",")));
								GridSetArray = StringSubstr(GridSetArray, StringFind(GridSetArray, ",") + 1);
								TPTemp = StrToInteger(StringSubstr(TP_SetArray, 0, StringFind(TP_SetArray, ",")));
								TP_SetArray = StringSubstr(TP_SetArray, StringFind(TP_SetArray, ",") + 1);
						}
						else SetTemp = MaxTrades;
						if (GridTemp == 0 || TPTemp == 0){
								Error = 1;
								break;
						}
						for (LevelTemp = Index; LevelTemp <= MathMin(Index + SetTemp - 1, MaxTrades - 1); LevelTemp ++){
								GridArray[LevelTemp, 0] = GridTemp;
								GridArray[LevelTemp, 1] = TPTemp;
						}
						Index = LevelTemp;
				}
				if (Error == 1 || GridArray[0, 0] == 0 || GridArray[0, 1] == 0){
						Print("Grid Array Error. Check that each 'Set' number has a corresponding 'Grid' and 'TP' number.");
						AllowTrading = false;
				}
     
				if (debug_msgs){
						for (Index = 0; Index < MaxTrades; Index ++){
								Print("GridArray " + Index + "  : [" + GridArray[Index, 0] + "," + GridArray[Index, 1] +"]");}
				} 
		}
		else{
				Index = 0;
				while (Index < 4){
						SetTemp = StrToInteger(StringSubstr(SetCountArray, 0, StringFind(SetCountArray, ",")));
						SetCountArray = StringSubstr(SetCountArray, StringFind(SetCountArray, DoubleToStr(SetTemp, 0)) + 2);
						if (Index == 0 && SetTemp < 1){
								Error = 1;
								break;
						}
						if (Index == 0) Set1Level = SetTemp;
						else if (Index == 1 && SetTemp > 0) Set2Level = Set1Level + SetTemp;
						else if (Index == 1) Set2Level = 0;
						else if (Index == 2 && SetTemp > 0) Set3Level = Set2Level + SetTemp;
						else if (Index == 2) Set3Level = 0;
						else if (Index == 3 && SetTemp > 0) Set4Level = Set3Level + SetTemp;
						else if (Index == 3) Set4Level = 0;
						Index ++;
				}
				if (Error == 1 || Set1Level == 0){
						Print("Error setting up the Grid Levels. Check that the SetCountArray has valid numbers, separated by a comma.");
						AllowTrading = false;
				}
		}

		//+-----------------------------------------------------------------+
		//| Set email parameters                                            |
		//+-----------------------------------------------------------------+

		if		(Period() == 43200) TF = "MN1";
		else if (Period() == 10800) TF = "W1";
		else if (Period() == 1440) TF = "D1";
		else if (Period() == 240) TF = "H4";
		else if (Period() == 60) TF = "H1";
		else if (Period() == 30) TF = "M30";
		else if (Period() == 15) TF = "M15";
		else if (Period() == 5) TF = "M5";
		else if (Period() == 1) TF = "M1";

		if (EmailDD1 >= MaxDDPercent) EmailDD1 = MaxDDPercent - 1;
		else if (EmailDD1 < 0) EmailDD1 = 0;
		if (EmailDD2 >= MaxDDPercent) EmailDD2 = MaxDDPercent - 1;
		else if (EmailDD2 < 0) EmailDD2 = 0;
		if (EmailDD3 >= MaxDDPercent) EmailDD3 = MaxDDPercent - 1;
		else if (EmailDD3 < 0) EmailDD3 = 0;
		
		if (EmailDD1 > EmailDD2){
				Error = EmailDD1;
				EmailDD1 = EmailDD2;
				EmailDD2 = Error;
		}
		if (EmailDD2 > EmailDD3){
				Error = EmailDD2;
				EmailDD2 = EmailDD3;
				EmailDD3 = Error;
		}
		if (EmailDD1 > EmailDD2){
				Error = EmailDD1;
				EmailDD1 = EmailDD2;
				EmailDD2 = Error;
		}
		if (EmailDD1 == 0 || EmailDD1 == EmailDD2){
				EmailDD1 = EmailDD2;
				EmailDD2 = 0;
		}
		if (EmailDD2 == 0 || EmailDD2 == EmailDD3){
				EmailDD2 = EmailDD3;
				EmailDD3 = 0;
		}
		if (EmailDD1 == 0 || EmailDD1 == EmailDD2){
				EmailDD1 = EmailDD2;
				EmailDD2 = 0;
		}
 		return(0);
}

//+-----------------------------------------------------------------+
//| expert deinitialization function                                |
//+-----------------------------------------------------------------+

int deinit(){

		LabelDelete();
		return(0);
}

//+-----------------------------------------------------------------+
//| expert start function                                           |
//+-----------------------------------------------------------------+

int start(){
		int     y;
		int     cb          =0;     // Count buy
		int     cs          =0;     // Count sell
		int     cbl         =0;     // Count buy limit
		int     csl         =0;     // Count sell limit
		double  blo         =0;     // Buy limit open price
		double  slo         =0;     // Sell limit open price
		int     cbs         =0;     // Count buy stop
		int     css         =0;     // Count sell stop
		double  tbl         =0;     // Count buy lots
		double  tsl         =0;     // Count sell lots
		double  tl          =0;     // total lots out
		int     to          =0;     // total buy and sell order out
		double  buysl       =0;     // stop losses are set to zero if POSL off
		double  sellsl      =0;     // stop losses are set to zero if POSL off
		double  POSL        =0;     // Initialize POSL
		double  ProfitPot   =0;     // The Potential Profit of a basket of Trades
		double  CurrentTP   =0;     // The current take profit of all orders
		double  m,lot2;
		double  lp;                 // last buy price
		double  ll;                 // last lot
		double  ltp;                // last tp
		double  lopt;               // last open time
		double  g2;
		double  tp2;
		double  entry;
		int     lticket;
		double  ma;
		double  stddev;
		double  bup, bux;
		double  bdn, bdx;
		int     zoneBUY     = BuySellStochZone;
		int     zoneSELL    = 100 - BuySellStochZone;
		double  pr          = 0;
		bool    syncOccurred=false;
		double  ProfitTarget;
		double  BEPoint;
		bool    SyncTPs;
		Comment("");

		//+-----------------------------------------------------------------+
		//| Calculate Total Profits, Profit Potential and Total Orders      |
		//+-----------------------------------------------------------------+

		pipvalue=MarketInfo(Symbol(),MODE_TICKVALUE);
		for (y = 0; y < OrdersTotal(); y++){
				if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
				if (OrderMagicNumber() != magic || OrderSymbol() != Symbol()) continue;
				if (OrderType()==OP_BUY){
						cb ++;
						pr += OrderProfit() + OrderSwap() + OrderCommission();
						tbl += OrderLots();
						ProfitPot += OrderSwap() + OrderCommission() + OrderLots()*pipvalue*(((OrderTakeProfit() - OrderOpenPrice())/Point));
						CurrentTP = OrderTakeProfit();
						BEPoint += OrderLots() * OrderOpenPrice();

						lp = OrderOpenPrice();
						ll = OrderLots();
						if (ltp > 0 && ltp != OrderTakeProfit()) SyncTPs = true;
						if (OrderTakeProfit() > 0) ltp = OrderTakeProfit();
						else SyncTPs = true;
						lopt = OrderOpenTime();
						lticket = OrderTicket();
				}
				else if (OrderType()==OP_SELL){
						cs ++;
						pr += OrderProfit() + OrderSwap() + OrderCommission();
						tsl += OrderLots();
						ProfitPot += OrderSwap() + OrderCommission() + OrderLots()*pipvalue*(((OrderOpenPrice() - OrderTakeProfit())/Point));
						CurrentTP = OrderTakeProfit();
						BEPoint += OrderLots() * OrderOpenPrice();

						lp = OrderOpenPrice();
						ll = OrderLots();
						if (ltp > 0 && ltp != OrderTakeProfit()) SyncTPs = true;
						if (OrderTakeProfit() > 0) ltp = OrderTakeProfit();
						else SyncTPs = true;
						lopt = OrderOpenTime();
						lticket = OrderTicket();
				}
				else {
						if (OrderType()==OP_BUYLIMIT){ 
								cbl ++;
								blo = OrderOpenPrice();
						}
						else if (OrderType()==OP_SELLLIMIT){
								csl ++;
								slo = OrderOpenPrice();
						}
						else if (OrderType()==OP_BUYSTOP) cbs ++;
						else if (OrderType()==OP_SELLSTOP) css ++;
				}
		}
		tl=tbl+tsl;
		to=cb+cs;
		if (tl > 0) BEPoint /= tl;

		BEPoint = NormalizeDouble(BEPoint,Digits);
		ProfitPot = NormalizeDouble(ProfitPot,2);
		pr = NormalizeDouble(pr,2);

		//+-----------------------------------------------------------------+
		//| Delete hanging pending orders                                   |
		//+-----------------------------------------------------------------+

		if (to == 0 && !DelLot2){
				DelLot1 = false;
				for (y = 0; y < OrdersTotal(); y++){
						if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
						if (OrderMagicNumber() != magic || OrderSymbol() != Symbol() || OrderType() < 2) continue;
						if (OrderLots() > lot) OrderDelete(OrderTicket());
				}
				DelLot2 = true;
				if (debug_msgs) Print("Delete pending > lot");
				return;
		}
		else if (to > 0 && !DelLot1){
				DelLot2 = false;
				for (y = 0; y < OrdersTotal(); y++){
						if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
						if (OrderMagicNumber() != magic || OrderSymbol() != Symbol() || OrderType() < 2) continue;
						if (OrderLots() == lot) OrderDelete(OrderTicket());
				}
				DelLot1 = true;
				if (debug_msgs) Print("Delete pending = lot");
				return;
		}
		//+-----------------------------------------------------------------+
		//| Check ca and Emergency Close All                                |
		//+-----------------------------------------------------------------+

		if (to==0 && cbs==0 && cbl==0 && css==0 && csl==0) ca=false;

		if (ca){    
				ExitAllTrades(Red, "Close All");
				return;
		}

		if (EmergencyCloseAll){
				ExitAllTrades(Red, "Emergency Close All Trades");
				EmergencyCloseAll = False;
				return;
		}

		//+-----------------------------------------------------------------+
		//| Check if trading is allowed                                     |
		//+-----------------------------------------------------------------+

		if (to == 0 && ShutDown){ 
				if (AllowTrading){
						Print("Blessing has ShutDown. Set ShutDown = 'false' to continue trading");
						AllowTrading = False;
				}
				if (cbs>0 || cbl>0 || css>0 || csl > 0) ExitAllTrades(Red, "ShutDown is true");

				if (UseEmail && EmailCount < 4 && !Testing){
						SendMail("Blessing EA", "Blessing has shut down on " + Symbol() + " " + TF + 
								". Trading has been suspended. To resume trading, set ShutDown to false.");
						Error = GetLastError();
						if (Error > 0) Print ("Error sending Email: " + Error + " " + ErrorDescription(Error));
						EmailCount = 4;
				}
		}
		if (!AllowTrading){
				LabelDelete();
				if (ObjectFind("B3Stopped") == -1){
						ObjectCreate("B3Stopped",OBJ_LABEL,0,0,0);
						ObjectSetText("B3Stopped","Trading has been stopped on this pair.",displayFontSize+10,"Arial Bold",Red);
						ObjectSet("B3Stopped",OBJPROP_CORNER,0);
						ObjectSet("B3Stopped",OBJPROP_XDISTANCE,(displayXcord));
						ObjectSet("B3Stopped",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*3)));
				}
				if (ObjectFind("B3Journal") == -1){
						ObjectCreate("B3Journal",OBJ_LABEL,0,0,0);
						ObjectSetText("B3Journal","Check the Experts tab for the reason why.",displayFontSize+10,"Arial Bold",Red);
						ObjectSet("B3Journal",OBJPROP_CORNER,0);
						ObjectSet("B3Journal",OBJPROP_XDISTANCE,(displayXcord));
						ObjectSet("B3Journal",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*6)));
				}
				if (ObjectFind("B3Resume") == -1){
						ObjectCreate("B3Resume",OBJ_LABEL,0,0,0);
						ObjectSetText("B3Resume","Reset Blessing to resume trading.",displayFontSize+10,"Arial Bold",Red);
						ObjectSet("B3Resume",OBJPROP_CORNER,0);
						ObjectSet("B3Resume",OBJPROP_XDISTANCE,(displayXcord));
						ObjectSet("B3Resume",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*9)));
				}
				return;
		}
		else {
				if (ObjectFind("B3Stopped") != -1) ObjectDelete("B3Stopped");
				if (ObjectFind("B3Journal") != -1) ObjectDelete("B3Journal");
				if (ObjectFind("B3Resume") != -1) ObjectDelete("B3Resume");
		}

		//+-----------------------------------------------------------------+
		//| ATR for Auto Grid Calculation and Grid Set Block                |
		//+-----------------------------------------------------------------+

		if (AutoCal){
				double atrvalue = iATR(NULL,PERIOD_D1,21,0);

				if (Digits < 4) GridSet1 = atrvalue*100/5;
				else GridSet1 = atrvalue*10000/5;

				TP_Set1   = GridSet1 * 2;
				GridSet2  = TP_Set1;
				TP_Set2   = GridSet2 * 2;
				GridSet3  = TP_Set2;
				TP_Set3   = GridSet3 * 2;
				GridSet4  = TP_Set3;
				TP_Set4   = GridSet4 * 1.5;
				GridSet5  = TP_Set4;
				TP_Set5   = GridSet5 * 1.5;
				if ((cb >= Set4Level || cs >= Set4Level) && Set4Level > 0){
						g2 = GridSet5;
						tp2 = TP_Set5;
				}
				else if ((cb >= Set3Level || cs >= Set3Level) && Set3Level > 0){
						g2 = GridSet4;
						tp2 = TP_Set4;
				}
				else if ((cb >= Set2Level || cs >= Set2Level) && Set2Level > 0){
						g2 = GridSet3;
						tp2 = TP_Set3;
				}
				else if ((cb >= Set1Level || cs >= Set1Level) && Set1Level > 0){
						g2 = GridSet2;
						tp2 = TP_Set2;
				}
				else{
						g2 = GridSet1;
						tp2 = TP_Set1;
				}
		}
		else{
				if (to <= MaxTrades){
						y = MathMax(to-1,0);
						g2 = GridArray[y, 0];
						tp2 = GridArray[y,1];
				} 
				else{
						g2 = GridArray[MaxTrades-1, 0];
						tp2 = GridArray[MaxTrades-1,1];                
				}
		}
		g2  = NormalizeDouble(g2 * BrokerDecimal * GAF,0);
		tp2 = NormalizeDouble(tp2 * BrokerDecimal * GAF,0);

		//+-----------------------------------------------------------------+
		//| Synchronize TP's / Set TP on Open Order created by BBStoch      |
		//+-----------------------------------------------------------------+

		if (SyncTPs){
				for (y = 0; y < OrdersTotal(); y++){
						if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
						if (OrderMagicNumber() != magic || OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
						if (OrderType() == OP_BUY){
								if (OrderTakeProfit() == 0){
									  ModifyOrder(OrderOpenPrice() ,OrderStopLoss(), (OrderOpenPrice() + tp2 * Point), Blue);
									  if (debug_msgs) Print("SetTP Buy");
								}
								else if (OrderTakeProfit() != ltp){
											ModifyOrder(OrderOpenPrice(), OrderStopLoss(), ltp, Red);
											if (debug_msgs) Print("SyncTP Buy");
								}
						}
						else if (OrderType() == OP_SELL){
								if (OrderTakeProfit() == 0){
										ModifyOrder(OrderOpenPrice(),OrderStopLoss() , (OrderOpenPrice() - tp2 * Point), Red);
										if (debug_msgs) Print("SetTP Sell");
								}
								else if (OrderTakeProfit() != ltp){
										ModifyOrder(OrderOpenPrice(), OrderStopLoss(), ltp, Red);
										if (debug_msgs) Print("SyncTP Sell");
								}
						}
				}
				return;
		}

		//+-----------------------------------------------------------------+
		//| Money Management and Lot size coding                            |
		//+-----------------------------------------------------------------+

		if (UseMM){
				double Contracts, Factor, Lotsize;

				Contracts = (AccountBalance() / 10000) / Portion;

				Factor = (MathPow(Multiplier, Level) - Multiplier) / (Multiplier - 1);

				Lotsize = LAF * Accounttype * (Contracts / (1.0 + Factor));

				if (Lotsize > 100 / MathPow(Multiplier, (Level - 1)) && Accounttype == 1) Lotsize = 100 / MathPow(Multiplier, (Level - 1));
				if (Lotsize > 50 / MathPow(Multiplier, (Level - 1)) && Accounttype == 10) Lotsize = 50 / MathPow(Multiplier, (Level - 1));
				lot = LotSize(Lotsize);
		}
      
      //+-----------------------------------------------------------------+
		//| Adjust TP if ProfitPot is negative/low/below grid profit        |
		//+-----------------------------------------------------------------+
		
		if (to == 0) BaseTarget = 0.0;
		if (BaseTarget <=0 && to > 0) BaseTarget = lot * pipvalue * BrokerDecimal * GridArray[0, 1];
						
		ProfitTarget = NormalizeDouble(BaseTarget,2)*to;

		if (ProfitPot < ProfitTarget){
				double newTP;
				if (cb > 0 && CurrentTP > 0.0){
						newTP = NormalizeDouble(BEPoint + ProfitTarget / pipvalue * Point / tl, Digits);
						for (y = 0; y < OrdersTotal(); y++){
								if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
								if ((OrderMagicNumber() != magic) || (OrderType()!=OP_BUY) || (OrderSymbol()!=Symbol())) continue;
								if (NormalizeDouble(OrderTakeProfit(), Digits) != newTP){
										syncOccurred=true;
										ModifyOrder(OrderOpenPrice(),OrderStopLoss(),newTP,Red);
										if (debug_msgs) Print("AdjTP Buy");
								}
						}
				}
				else if (cs > 0 && CurrentTP > 0.0){
						newTP = NormalizeDouble(BEPoint - ProfitTarget / pipvalue * Point / tl, Digits);
						for (y = 0; y < OrdersTotal(); y++){
								if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
								if ((OrderMagicNumber() != magic) || (OrderType()!=OP_SELL) || (OrderSymbol()!=Symbol())) continue;
								if (NormalizeDouble(OrderTakeProfit(), Digits) != newTP){
										syncOccurred=true;
										ModifyOrder(OrderOpenPrice(),OrderStopLoss(),newTP,Red);
										if (debug_msgs) Print("AdjTP Sell");
								}
						}
				}
				if (syncOccurred) return;
		}

		//+-----------------------------------------------------------------+
		//| Maximize Profit with Moving TP and setting Trailing Profit Stop |
		//+-----------------------------------------------------------------+

		if (((cb >= BreakEvenTrade || cs >= BreakEvenTrade) && pr > 0)){
				ExitAllTrades(Lime,"Break Even Function Triggered");
				return;
		}

		if (MaximizeProfit){
				if (to == 0){
						counter  = 0;
						moves    = 0;
						ProfitSL = 0;
				}

				if (ProfitSL > 0 && pr <= ProfitSL){
						ExitAllTrades(Green,"Profit Trailing Stop Reached");
						return;
				}

				if (ProfitPot > 0 && pr > ProfitPot * ProfitSet / 100) ProfitSL = ProfitPot * ProfitSet / 100;

				if (ProfitSL > 0 && ProfitSL > counter && MoveTP > 0 && TotalMoves > moves){
						for (y = 0; y < OrdersTotal(); y++){
								if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
								if (OrderMagicNumber() != magic || OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
								if (OrderType()==OP_BUY){
										ModifyOrder(OrderOpenPrice(),OrderStopLoss(),(CurrentTP + (MoveTP * Point)),Blue);
										if (debug_msgs) Print("MoveTP Buy");
								}
								else if (OrderType()==OP_SELL){
										ModifyOrder(OrderOpenPrice(),OrderStopLoss(),(CurrentTP - (MoveTP * Point)),Red);
										if (debug_msgs) Print("MoveTP Sell");
								}
						}
						moves++;
						counter = ProfitSL;
						return;
				}
		}

		//+-----------------------------------------------------------------+
		//| Account Protection                                              |
		//+-----------------------------------------------------------------+

		double PortionBalance = NormalizeDouble(AccountBalance() / Portion, 2);

		if ( -pr >= (PortionBalance * MaxDDPercent / 100) )
				ExitAllTrades(Red,"Equity Stop Loss Reached");

		if ( -pr > MaxDD) MaxDD = -pr;
		MaxDDPer = MathMax(MaxDDPer, MaxDD / PortionBalance * 100);

		//+-----------------------------------------------------------------+
		//| Check DD% and send Email                                        |
		//+-----------------------------------------------------------------+

		if (UseEmail && !Testing){
				if (EmailCount == 0 && EmailDD1 > 0 && -pr / PortionBalance * 100 > EmailDD1){
						SendMail("Blessing EA", "Blessing has reached a drawdown of " + EmailDD1 + "% on " + Symbol() + " " + TF);
						Error = GetLastError();
						if (Error > 0) Print ("Error: " + Error + " " + ErrorDescription(Error));
						EmailSent = TimeCurrent();
						EmailCount = 1;
				}
				if (EmailCount == 1 && EmailDD2 > 0 && -pr / PortionBalance * 100 > EmailDD2){
						SendMail("Blessing EA", "Blessing has reached a drawdown of " + EmailDD2 + "% on " + Symbol() + " " + TF);
						Error = GetLastError();
						if (Error > 0) Print ("Error: " + Error + " " + ErrorDescription(Error));
						EmailSent = TimeCurrent();
						EmailCount = 2;
				}
				else if (EmailCount == 1 && -pr / PortionBalance * 100 < EmailDD1 && TimeCurrent() > EmailSent + EmailHours * 3600 ){
						EmailCount = 0;
				}
				if (EmailCount == 2 && EmailDD3 > 0 && -pr / PortionBalance * 100 > EmailDD3){
						SendMail("Blessing EA", "Blessing has reached a drawdown of " + EmailDD3 + "% on " + Symbol() + " " + TF);
						Error = GetLastError();
						if (Error > 0) Print ("Error: " + Error + " " + ErrorDescription(Error));
						EmailSent = TimeCurrent();
						EmailCount = 3;
				}
				else if (EmailCount == 2 && -pr / PortionBalance * 100 < EmailDD2 && TimeCurrent() > EmailSent + EmailHours * 3600 ){
						EmailCount = 1;
				}
		}

		//+-----------------------------------------------------------------+
		//| Trading with EA Criteria                                        |
		//+-----------------------------------------------------------------+

		double StepAB = InitialAB + InitialAB * (StopTradePercent / 100);
		double StepSTB = AccountBalance() - AccountBalance()*(StopTradePercent / 100);
		double NextISTB = StepAB - StepAB*(StopTradePercent / 100);

		if (StepSTB > NextISTB){
				InitialAB = StepAB;
				StopTradeBalance = StepSTB;
		}

		double InitialAccountMultiPortion = StopTradeBalance/Portion;

		if (PortionBalance < InitialAccountMultiPortion){
				PlaySound("alert.wav");
				Print("Account Balance dropped below stop trade percent");
				MessageBox( "Reset Blessing, account balance dropped below stop trade percent on " + Symbol()+ Period(), "Blessing 3: Warning", 48 );
				AllowTrading = False;
				return (0);
		}

		//+-----------------------------------------------------------------+
		//| Power Out Stop Loss Protection                                  |
		//+-----------------------------------------------------------------+

		if (UsePowerOutSL){
				if (tl > 0) POSL = MathMin(NormalizeDouble((PortionBalance * (MaxDDPercent + 1) / 100) / (pipvalue * tl * BrokerDecimal), 0), 600);
				else POSL = 600;

				buysl = Ask - (POSL * BrokerDecimal) * Point;
				sellsl = Bid + (POSL * BrokerDecimal) * Point;

				if (to == 0) count = 0;
				if (to > 0 && to > count){ // sync up order stop losses

						for (y = 0; y < OrdersTotal(); y++){
								if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
								if (OrderMagicNumber() != magic || OrderSymbol() != Symbol() || OrderType() > OP_SELL) continue;
								if (OrderType() == OP_BUY){ 
										ModifyOrder(OrderOpenPrice(), buysl, OrderTakeProfit(), Purple);
										if (debug_msgs) Print("Sync SL Buy");
								}
								else if (OrderType() == OP_SELL){
										ModifyOrder(OrderOpenPrice(), sellsl, OrderTakeProfit(), Purple);
										if (debug_msgs) Print("Sync SL Sell");
								}
						}
				}
				count = to;
		}

		//+-----------------------------------------------------------------+
		//| Moving Average Indicator for Calculation of Trend Direction     |
		//+-----------------------------------------------------------------+

		int MC_final = 2;
		if (ForceMarketCond == 3){
				double ima_0 = iMA(Symbol(),0,MAPeriod,0,MODE_EMA,PRICE_CLOSE,0);
				if (Bid < ima_0 - MADistance * Point) MC_final = 1;
				else if (Bid > ima_0 + MADistance * Point) MC_final = 0;
		}
		else  MC_final = ForceMarketCond;

		//+------------------------------------------------------------------+
		//|Uses CCI of 5M,15M,30M,1H to determine Market Condition (MC_final)|
		//+------------------------------------------------------------------+

		if (CCIEntry && ForceMarketCond == 3){
				double cci_01 = iCCI(Symbol(),PERIOD_M5,14,PRICE_CLOSE,0);
				double cci_02 = iCCI(Symbol(),PERIOD_M15,14,PRICE_CLOSE,0);
				double cci_03 = iCCI(Symbol(),PERIOD_M30,14,PRICE_CLOSE,0);
				double cci_04 = iCCI(Symbol(),PERIOD_H1,14,PRICE_CLOSE,0);
				double cci_11 = iCCI(Symbol(),PERIOD_M5,14,PRICE_CLOSE,1);
				double cci_12 = iCCI(Symbol(),PERIOD_M15,14,PRICE_CLOSE,1);
				double cci_13 = iCCI(Symbol(),PERIOD_M30,14,PRICE_CLOSE,1);
				double cci_14 = iCCI(Symbol(),PERIOD_H1,14,PRICE_CLOSE,1);

				if (cci_11 > 0 && cci_12 > 0 && cci_13 > 0 && cci_14 > 0
						&& cci_01 > 0 && cci_02 > 0 && cci_03 > 0 && cci_04 > 0) MC_final = 0;
				else if (cci_11 < 0 && cci_12 < 0 && cci_13 < 0 && cci_14 < 0
						&& cci_01 < 0 && cci_02 < 0 && cci_03 < 0 && cci_04 < 0) MC_final = 1;
		}

		//+-----------------------------------------------------------------+
		//| Bollinger Band trade Long/Short                                 |
		//+-----------------------------------------------------------------+

		if (BollingerStochEntry){
				ma = iMA(Symbol(),0,BollPeriod,0,MODE_SMA,PRICE_OPEN,0);
				stddev = iStdDev(Symbol(),0,BollPeriod,0,MODE_SMA,PRICE_OPEN,0);

				bup = ma+(BollDeviation*stddev);
				bdn = ma-(BollDeviation*stddev);

				bux=(bup+(BollDistance*Point));
				bdx=(bdn-(BollDistance*Point));
		}

		//+-----------------------------------------------------------------+
		//| Trade Selection Logic                                           |
		//+-----------------------------------------------------------------+

		if ((cb==0) && (cs==0)){
				if (BollingerStochEntry == false){
						if (MC_final == 0){
								if (cbs==0 && csl==0){
										m=MathMod(Ask/Point,g2);
										if ((g2-m+EntryOffset)>MarketInfo(Symbol(),MODE_STOPLEVEL)){
												SendOrder(OP_BUYSTOP,lot,Ask+(g2-m+EntryOffset)*Point,0,buysl,Ask+(g2-m+EntryOffset+tp2)*Point,CLR_NONE);
												if (debug_msgs) Print("BuyStop MC=0");
												return;
										}
								}
								if (cbl==0 && css==0){
										m=MathMod(Ask/Point,g2);
										if ((m+EntryOffset)>MarketInfo(Symbol(),MODE_STOPLEVEL)){
												SendOrder(OP_BUYLIMIT,lot,Ask-(m+EntryOffset)*Point,0,buysl,Ask-(m+EntryOffset-tp2)*Point,CLR_NONE);
												if (debug_msgs) Print("BuyLimit MC=0");
												return;
										}
								}
						}
						else if (MC_final==1){
								if (csl==0 && cbs==0){
										m=MathMod(Bid/Point,g2);
										if ((g2-m-EntryOffset)>MarketInfo(Symbol(),MODE_STOPLEVEL)){
												SendOrder(OP_SELLLIMIT,lot,Bid+(g2-m-EntryOffset)*Point,0,sellsl,Bid+(g2-m-EntryOffset-tp2)*Point,CLR_NONE);
												if (debug_msgs) Print("SellLimit MC=1");
												return;
										}
								}
								if (css==0 && cbl==0){
										m=MathMod(Bid/Point,g2);
										if ((m+EntryOffset)>MarketInfo(Symbol(),MODE_STOPLEVEL)){
												SendOrder(OP_SELLSTOP,lot,Bid-(m+EntryOffset)*Point,0,sellsl,Bid-(m+EntryOffset+tp2)*Point,CLR_NONE);
												if (debug_msgs) Print("SellStop MC=1");
												return;
										}
								}
						}
						else if (MC_final==2){
								if (css == 0 && cbl == 0){
										m=MathMod(Bid/Point,g2);
										if ((m+EntryOffset)>MarketInfo(Symbol(),MODE_STOPLEVEL)){
												SendOrder(OP_SELLSTOP,lot,Bid-(m+EntryOffset)*Point,0,sellsl,Bid-(m+EntryOffset+tp2)*Point,CLR_NONE);
												if (debug_msgs) Print("SellStop MC=2");
												return;
										}
								}
								if (cbs== 0 && csl == 0){
										m=MathMod(Ask/Point,g2);
										if ((g2-m+EntryOffset)>MarketInfo(Symbol(),MODE_STOPLEVEL)){
												SendOrder(OP_BUYSTOP,lot,Ask+(g2-m+EntryOffset)*Point,0,buysl,Ask+(g2-m+EntryOffset+tp2)*Point,CLR_NONE);
												if (debug_msgs) Print("BuyStop MC=2");
												return;
										}
								}
						}
				} 
				else if (BollingerStochEntry == True){
						double stoc_0 = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_LWMA,1,0,1);
						double stoc_1 = iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_LWMA,1,1,1);
						if (Close[0] < bdx && stoc_0 < zoneBUY && stoc_1 < zoneBUY){
								SendOrder(OP_BUY,lot,Ask,slip,0,0,Blue);
								if (debug_msgs) Print("BBStoch Buy");
								return;
						}
						if (Close[0] > bux && stoc_0 > zoneSELL && stoc_1 > zoneSELL){
								SendOrder(OP_SELL,lot,Bid,slip,0,0,Red);
								if (debug_msgs) Print("BBStoch Sell");
								return;
						}      
				}
		}
		else if (cb>0){
				if ((TimeCurrent()-EntryDelay>lopt) && (cb<MaxTrades)){
						if (lp>Ask) entry=NormalizeDouble(lp-(MathRound((lp-Ask)/Point/g2)+1)*g2*Point,Digits);
						else entry=NormalizeDouble(lp-g2*Point,Digits);
						if (LinearLotSize) lot2 = MathMax(LotSize(ll + lot), LotSize(ll + MinLotStep));
						else lot2 = MathMax(LotSize(ll * Multiplier), LotSize(ll + MinLotStep));
						if (cbl==0){
								SendOrder(OP_BUYLIMIT,lot2,entry,0,buysl,entry+tp2*Point);
								if (debug_msgs) Print("BuyLimit grid");
								return;
						}
						else if (cbl==1 && entry - blo > g2 / 2 * Point){
								for (y = OrdersTotal() - 1; y >= 0 ; y --){
										if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
										if ((OrderMagicNumber() != magic)  || (OrderSymbol() != Symbol()) || (OrderType() != OP_BUYLIMIT)) continue;
										ModifyOrder(entry, buysl, entry + tp2 * Point);
										if (debug_msgs) Print("Mod BuyLimit entry");
										return;
								}
						}
				}
		}
		else if (cs>0){
				if ((TimeCurrent()-EntryDelay>lopt) && (cs<MaxTrades)){
						if (Bid>lp) entry=NormalizeDouble(lp+(MathRound((-lp+Bid)/Point/g2)+1)*g2*Point,Digits);
						else entry=NormalizeDouble(lp+g2*Point,Digits);
						if (LinearLotSize) lot2 = MathMax(LotSize(ll + lot), LotSize(ll + MinLotStep));
						else lot2 = MathMax(LotSize(ll * Multiplier), LotSize(ll + MinLotStep));
						if (csl == 0){
								SendOrder(OP_SELLLIMIT,lot2,entry,0,sellsl,entry-tp2*Point);
								if (debug_msgs) Print("SellLimit grid");
								return;
						}
						else if (csl == 1 && slo - entry > g2 / 2 * Point){
						for (y = OrdersTotal() - 1; y >= 0 ; y--){
							if (!OrderSelect (y, SELECT_BY_POS, MODE_TRADES)) continue;
							if ((OrderMagicNumber() != magic)  || (OrderSymbol() != Symbol()) || (OrderType() != OP_SELLLIMIT)) continue;
							ModifyOrder(entry, sellsl, entry - tp2 * Point);
							if (debug_msgs) Print("Mod SellLimit entry");
							return;
						}
						}
				}
		}
		//+-----------------------------------------------------------------+
		//| External Script Code                                            |
		//+-----------------------------------------------------------------+
		if ((Testing && Visual) || !Testing){
				if (displayOverlay){
						ObjectSetText("B3VTime",TimeToStr(TimeCurrent(), TIME_SECONDS),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VLEPRisked",DoubleToStr(MaxDDPercent, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VLotSize",DoubleToStr(lot, 2),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VLots",DoubleToStr(tl, 2),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VProfitPot",DoubleToStr(ProfitPot, 2),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VProfitSL",DoubleToStr(ProfitSL, 2),displayFontSize,"Arial Bold",displayColor);
						if (MC_final == 0){
								ObjectSetText("B3Trend","Trend is UP",displayFontSize+10,"Arial Bold",Green);
								if (ObjectFind("B3TrendArrow") == -1){
										ObjectCreate("B3TrendArrow",OBJ_LABEL,0,0,0);
										ObjectSet("B3TrendArrow",OBJPROP_CORNER,0);
								}
								ObjectSetText("B3TrendArrow","",displayFontSize+9,"Wingdings",Green);
								ObjectSet("B3TrendArrow",OBJPROP_XDISTANCE,(displayXcord+160));
								ObjectSet("B3TrendArrow",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*20)));
						} 
						else if (MC_final == 1){
								ObjectSetText("B3Trend","Trend is DOWN",displayFontSize+10,"Arial Bold",Red);
								if (ObjectFind("B3TrendArrow") == -1){
										ObjectCreate("B3TrendArrow",OBJ_LABEL,0,0,0);
										ObjectSet("B3TrendArrow",OBJPROP_CORNER,0);
								}
								ObjectSetText("B3TrendArrow","",displayFontSize+9,"Wingdings",Red);
								ObjectSet("B3TrendArrow",OBJPROP_XDISTANCE,(displayXcord+210));
								ObjectSet("B3TrendArrow",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*20+5)));
						} 
						else if (MC_final == 2){
								ObjectSetText("B3Trend","Trend is Ranging",displayFontSize+10,"Arial Bold",Orange);
								if (ObjectFind("B3TrendArrow") != -1) ObjectDelete("B3TrendArrow");
						}
						ObjectSetText("B3VBuy",DoubleToStr(cb, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VSell",DoubleToStr(cs, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VCurrentTP",DoubleToStr(CurrentTP, 5),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VMoveTP",DoubleToStr((MoveTP/BrokerDecimal), 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VMoves",DoubleToStr(moves, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VTotalMoves",DoubleToStr(TotalMoves, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VPortion",DoubleToStr(Portion, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VPCRisked",DoubleToStr(MaxDDPercent/Portion, 0),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VPortionPL",DoubleToStr(PortionBalance, 2),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VStopTrade",DoubleToStr(InitialAccountMultiPortion, 0),displayFontSize,"Arial Bold",Red);
						ObjectSetText("B3VMaxDD",DoubleToStr(MaxDD,2),displayFontSize,"Arial Bold",displayColor);
						ObjectSetText("B3VMaxDDPC",DoubleToStr(MaxDDPer,2),displayFontSize,"Arial Bold",displayColor);
						if (pr >= 0) ObjectSetText("B3VProfit",DoubleToStr(pr, 2),displayFontSize,"Arial Bold",Green);
						else ObjectSetText("B3VProfit",DoubleToStr(pr, 2),displayFontSize,"Arial Bold",Red);
						ObjectSetText("B3VStopTradePC",DoubleToStr(StopTradePercent, 0),displayFontSize,"Arial Bold",displayColor);
						if (displayLines){
								if (BEPoint > 0){
										if (ObjectFind("B3BELine") == -1){
												ObjectCreate("B3BELine",OBJ_HLINE,0,0,0);
												ObjectSet("B3BELine", OBJPROP_COLOR, DodgerBlue);
												ObjectSet("B3BELine", OBJPROP_WIDTH, 1);
												ObjectSet("B3BELine", OBJPROP_STYLE, 0);
										}
										ObjectMove("B3BELine", 0, Time[0], BEPoint);
								}
								else if (ObjectFind("B3BELine") != -1) ObjectDelete("B3BELine");

								if (CurrentTP > 0){
										if (ObjectFind("B3TPLine") == -1){
												ObjectCreate("B3TPLine",OBJ_HLINE,0,0,0);
												ObjectSet("B3TPLine", OBJPROP_COLOR, Gold);
												ObjectSet("B3TPLine", OBJPROP_WIDTH, 1);
												ObjectSet("B3TPLine", OBJPROP_STYLE, 0);
										}
										ObjectMove("B3TPLine", 0, Time[0], CurrentTP);
								}
								else if (ObjectFind("B3TPLine") != -1) ObjectDelete("B3TPLine");

								if (ProfitSL > 0){
										double TSLine;  
										if (ObjectFind("B3TSLine") == -1){
												ObjectCreate("B3TSLine",OBJ_HLINE,0,0,0);
												ObjectSet("B3TSLine", OBJPROP_COLOR, Gold);
												ObjectSet("B3TSLine", OBJPROP_WIDTH, 1);
												ObjectSet("B3TSLine", OBJPROP_STYLE, 3);
										}
										if (cb > 0) TSLine = NormalizeDouble(BEPoint + ProfitSL / pipvalue * Point / tl, Digits);
										else if (cs > 0) TSLine = NormalizeDouble(BEPoint - ProfitSL / pipvalue * Point / tl, Digits);
										ObjectMove("B3TSLine", 0, Time[0], TSLine);
								}
								else if (ObjectFind("B3TSLine") != -1) ObjectDelete("B3TSLine");
						}
						else{
								if (ObjectFind("B3BELine") != -1) ObjectDelete("B3BELine");
								if (ObjectFind("B3TPLine") != -1) ObjectDelete("B3TPLine");
								if (ObjectFind("B3TSLine") != -1) ObjectDelete("B3TSLine");
						}
						if (CCIEntry && displayCCI){
								if (cci_01 > 0 && cci_11 > 0) ObjectSetText("B3CCIm5V","",displayFontSize+6,"Wingdings",Green);
								else if (cci_01 < 0 && cci_11 < 0) ObjectSetText("B3CCIm5V","",displayFontSize+6,"Wingdings",Red);
								else ObjectSetText("B3CCIm5V","",displayFontSize+6,"Wingdings",Orange);
								if (cci_02 > 0 && cci_12 > 0) ObjectSetText("B3CCIm15V","",displayFontSize+6,"Wingdings",Green);
								else if (cci_02 < 0 && cci_12 < 0) ObjectSetText("B3CCIm15V","",displayFontSize+6,"Wingdings",Red);
								else ObjectSetText("B3CCIm15V","",displayFontSize+6,"Wingdings",Orange);
								if (cci_03 > 0 && cci_13 > 0) ObjectSetText("B3CCIm30V","",displayFontSize+6,"Wingdings",Green);
								else if (cci_03 < 0 && cci_13 < 0) ObjectSetText("B3CCIm30V","",displayFontSize+6,"Wingdings",Red);
								else ObjectSetText("B3CCIm30V","",displayFontSize+6,"Wingdings",Orange);
								if (cci_04 > 0 && cci_14 > 0) ObjectSetText("B3CCIh1V","",displayFontSize+6,"Wingdings",Green);
								else if (cci_04 < 0 && cci_14 < 0) ObjectSetText("B3CCIh1V","",displayFontSize+6,"Wingdings",Red);
						       else ObjectSetText("B3CCIh1V","",displayFontSize+6,"Wingdings",Orange);
						}
				}
				if (EmergencyWarning){
						if (ObjectFind("B3Close") == -1){
								ObjectCreate("B3Close",OBJ_LABEL,0,0,0);
								ObjectSet("B3Close",OBJPROP_CORNER,0);
								ObjectSet("B3Close",OBJPROP_XDISTANCE,(displayXcord));
								ObjectSet("B3Close",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*23)));
						}
						ObjectSetText("B3Close","WARNING: EmergencyCloseAll is set to TRUE",displayFontSize+5,"Arial Bold",Red);
				}
				else if (ShutDown){
						if (ObjectFind("B3Close") == -1){
								ObjectCreate("B3Close",OBJ_LABEL,0,0,0);
								ObjectSet("B3Close",OBJPROP_CORNER,0);
								ObjectSet("B3Close",OBJPROP_XDISTANCE,(displayXcord));
								ObjectSet("B3Close",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*23)));
						}
						ObjectSetText("B3Close","Blessing will stop trading when this basket closes.",displayFontSize+5,"Arial Bold",Red);
				}
				else if (ObjectFind("B3Close") != -1) ObjectDelete("B3Close");
		}
		return(0);
}

//+-----------------------------------------------------------------+
//| Check Lot Size Funtion                                          |
//+-----------------------------------------------------------------+

double LotSize(double Lot){
		Lot = NormalizeDouble(Lot, LotDecimal);
		Lot = MathMin(Lot, MarketInfo(Symbol(),MODE_MAXLOT));
		Lot = MathMax(Lot, MinLotSize);
		return (Lot);
}
//+-----------------------------------------------------------------+
//| Open Order Funtion                                              |
//+-----------------------------------------------------------------+

int SendOrder (int OCmd, double OLot, double OPrice, double OSlip, double OSL, double OTP, color OColor = CLR_NONE){
		int Ticket;
		int retryTimes=5,i =0;
		while(true && i<5){
				i+=1;
				while (IsTradeContextBusy()) Sleep(100);
				if (IsStopped()) return (-1);
				Ticket = OrderSend(Symbol(), OCmd, OLot, OPrice, OSlip, OSL, OTP, TradeComment, magic, 0, OColor);
				if (Ticket < 0){
						Error = GetLastError();
						if (Error != 0) Print("Error opening order: " + Error + " " + ErrorDescription(Error)
								+ " Symbol: " + Symbol()
								+ " TradeOP: " + OCmd
								+ " Lots: " + DoubleToStr(OLot , 2)
								+ " Price: " + DoubleToStr(OPrice, 5)
								+ " SL: " + OSL
								+ " TP: " + OTP);                         
						switch (Error) 
						{
							case ERR_SERVER_BUSY:
							case ERR_NO_CONNECTION:
							case ERR_INVALID_PRICE:
							case ERR_BROKER_BUSY:
							case ERR_TRADE_CONTEXT_BUSY: 
									i += 1;
									break;     
							case ERR_PRICE_CHANGED:
							case ERR_OFF_QUOTES:
							case ERR_REQUOTE:
									RefreshRates();
									continue; 
							default:
									i=retryTimes;
									break;      
						}                        
				} else break;
		}
		return (Ticket);
}

//+-----------------------------------------------------------------+
//| Modify Order Function                                           |
//+-----------------------------------------------------------------+

int ModifyOrder(double OrderOP, double OrderSL, double OrderTP, color Color = CLR_NONE){
		bool Success = false;
		int retryTimes=5,i =0;
		while(true && i<5 && !Success){
				i+=1;
				while (IsTradeContextBusy()) Sleep(100);
				if (IsStopped()) return (-1);
				Success = OrderModify(OrderTicket(), OrderOP, OrderSL, OrderTP, 0, Color);
				if (!Success){
						Error = GetLastError();
						if (Error > 1) Print(" Error Modifying Order:", OrderTicket(), ", ", Error, " :" + ErrorDescription(Error),
							", Ask:", Ask, ", Bid:", Bid, ", M_SL:", MarketInfo(Symbol(),MODE_STOPLEVEL), ", SL:", OrderSL,
							", OSL:", OrderStopLoss(), ", TP:", OrderTP, ", OTP:", OrderTakeProfit());
						else Success = True;
						switch (Error){
							case ERR_NO_ERROR:                        
							case ERR_NO_RESULT:
									i = retryTimes;
									break;                        
							case ERR_SERVER_BUSY:
							case ERR_NO_CONNECTION:
							case ERR_INVALID_PRICE:
							case ERR_OFF_QUOTES:
							case ERR_BROKER_BUSY:
							case ERR_TRADE_CONTEXT_BUSY: 
							case ERR_TRADE_TIMEOUT:
									i += 1;
									break;                        
							case ERR_PRICE_CHANGED:
							case ERR_REQUOTE:
									RefreshRates();
									continue;
							default:
									i = retryTimes;
									break;                         
						} 
				} else break;
		}
		return(Success);
}

//+-----------------------------------------------------------------+
//| Exit Trade Function                                             |
//+-----------------------------------------------------------------+

int ExitAllTrades(color Color, string reason){

		bool success;
		int Closed;
		string s;

		ca = true;
		for (int y = OrdersTotal() - 1; y >= 0; y --){
				if (!OrderSelect(y, SELECT_BY_POS, MODE_TRADES)) continue;
				if (OrderSymbol() != Symbol() || OrderMagicNumber() != magic) continue;
				if (IsTradeContextBusy()){
						while (True){
								if (IsStopped()) return(-1);
								if (!IsTradeContextBusy()) break;
								Sleep (100);
						}
				}
				if (OrderType()>OP_SELL){
						success = OrderDelete(OrderTicket(),Color);
						if (success) Closed ++;
						else {
							Error = GetLastError();
							Print("Order " , OrderTicket() , " failed to close. Error:" , ErrorDescription(Error));
						}
						continue;
				}
				else success=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(), slip, Color);

				if (success) Closed ++;
				else {
						Error = GetLastError();
						Print("Order " , OrderTicket() , " failed to close. Error:" , ErrorDescription(Error));
				}
		}
		if (Closed != 1) s = "s";
		Print("Closed " + Closed + " position" + s + " because ",reason);
		return (Closed);
}


//+-----------------------------------------------------------------+
//| Magic Number Generator                                          |
//+-----------------------------------------------------------------+

int GenerateMagicNumber(){
		if (EANumber > 99){
				magic = EANumber;
				return;
		}
		magic = JenkinsHash(EANumber + "_" + Symbol() + "_" + Period());
}

int JenkinsHash(string msg){
		int magic = 0;
		for (int i=0;i<StringLen(msg);i++) {
				magic += StringGetChar(msg,i);
				magic += (magic << 10);
				magic ^= (magic >> 6);
		}
		magic += (magic << 3);
		magic ^= (magic >> 11);
		magic += (magic << 15);
		magic = MathAbs(magic);
		return(magic);
}
//+------------------------------------------------------------------+
//| Delete Overlay Label Function                                    |
//+------------------------------------------------------------------+
void LabelDelete(){
		if (ObjectFind("B3Logo") != -1) ObjectDelete("B3Logo");
		if (ObjectFind("B3CRight") != -1) ObjectDelete("B3CRight");
		if (ObjectFind("B3MM") != -1) ObjectDelete("B3MM");
		if (ObjectFind("B3LTime") != -1) ObjectDelete("B3LTime");
		if (ObjectFind("B3LEP") != -1) ObjectDelete("B3LEP");
		if (ObjectFind("B3POSL") != -1) ObjectDelete("B3POSL");
		if (ObjectFind("B3LLotSize") != -1) ObjectDelete("B3LLotSize");
		if (ObjectFind("B3LProfitPot") != -1) ObjectDelete("B3LProfitPot");
		if (ObjectFind("B3LProfitSL") != -1) ObjectDelete("B3LProfitSL");
		if (ObjectFind("B3Trend") != -1) ObjectDelete("B3Trend");
		if (ObjectFind("B3TrendArrow") != -1) ObjectDelete("B3TrendArrow");
		if (ObjectFind("B3LBuy") != -1) ObjectDelete("B3LBuy");
		if (ObjectFind("B3LSell") != -1) ObjectDelete("B3LSell");
		if (ObjectFind("B3LCurrentTP") != -1) ObjectDelete("B3LCurrentTP");
		if (ObjectFind("B3LMoveTP") != -1) ObjectDelete("B3LMoveTP");
		if (ObjectFind("B3LMoves") != -1) ObjectDelete("B3LMoves");
		if (ObjectFind("B3LPortion") != -1) ObjectDelete("B3LPortion");
		if (ObjectFind("B3LPCRisked") != -1) ObjectDelete("B3LPCRisked");
		if (ObjectFind("B3LBalance") != -1) ObjectDelete("B3LBalance");
		if (ObjectFind("B3LStopTrade") != -1) ObjectDelete("B3LStopTrade");
		if (ObjectFind("B3LMaxDD") != -1) ObjectDelete("B3LMaxDD");
		if (ObjectFind("B3LPortionPL") != -1) ObjectDelete("B3LPortionPL");
		if (ObjectFind("B3LMaxDDPC") != -1) ObjectDelete("B3LMaxDDPC");
		if (ObjectFind("B3VProfit") != -1) ObjectDelete("B3VProfit");
		if (ObjectFind("B3LStopTradePC") != -1) ObjectDelete("B3LStopTradePC");
		if (ObjectFind("B3Line1") != -1) ObjectDelete("B3Line1");
		if (ObjectFind("B3VStopTradePC") != -1) ObjectDelete("B3VStopTradePC");
		if (ObjectFind("B3VTime") != -1) ObjectDelete("B3VTime");
		if (ObjectFind("B3VMaxDDPC") != -1) ObjectDelete("B3VMaxDDPC");
		if (ObjectFind("B3VLotSize") != -1) ObjectDelete("B3VLotSize");
		if (ObjectFind("B3VProfitPot") != -1) ObjectDelete("B3VProfitPot");
		if (ObjectFind("B3VProfitSL") != -1) ObjectDelete("B3VProfitSL");
		if (ObjectFind("B3VBuy") != -1) ObjectDelete("B3VBuy");
		if (ObjectFind("B3VSell") != -1) ObjectDelete("B3VSell");
		if (ObjectFind("B3VCurrentTP") != -1) ObjectDelete("B3VCurrentTP");
		if (ObjectFind("B3VMoveTP") != -1) ObjectDelete("B3VMoveTP");
		if (ObjectFind("B3VMoves") != -1) ObjectDelete("B3VMoves");
		if (ObjectFind("B3VPortion") != -1) ObjectDelete("B3VPortion");
		if (ObjectFind("B3VPCRisked") != -1) ObjectDelete("B3VPCRisked");
		if (ObjectFind("B3VLEPRisked") != -1) ObjectDelete("B3VLEPRisked");
		if (ObjectFind("B3VPortionPL") != -1) ObjectDelete("B3VPortionPL");
		if (ObjectFind("B3VStopTrade") != -1) ObjectDelete("B3VStopTrade");
		if (ObjectFind("B3VMaxDD") != -1) ObjectDelete("B3VMaxDD");
		if (ObjectFind("B3VMaxDDPC") != -1) ObjectDelete("B3VMaxDDPC");
		if (ObjectFind("B3Line2") != -1) ObjectDelete("B3Line2");
		if (ObjectFind("B3LPrMax") != -1) ObjectDelete("B3LPrMax");
		if (ObjectFind("B3Slash") != -1) ObjectDelete("B3Slash");
		if (ObjectFind("B3VTotalMoves") != -1) ObjectDelete("B3VTotalMoves");
		if (ObjectFind("B3LLots") != -1) ObjectDelete("B3LLots");
		if (ObjectFind("B3VLots") != -1) ObjectDelete("B3VLots");
		if (ObjectFind("B3BELine") != -1) ObjectDelete("B3BELine");
		if (ObjectFind("B3TPLine") != -1) ObjectDelete("B3TPLine");
		if (ObjectFind("B3TSLine") != -1) ObjectDelete("B3TSLine");
		if (ObjectFind("B3Stopped") != -1) ObjectDelete("B3Stopped");
		if (ObjectFind("B3Journal") != -1) ObjectDelete("B3Journal");
		if (ObjectFind("B3Resume") != -1) ObjectDelete("B3Resume");
		if (ObjectFind("B3Close") != -1) ObjectDelete("B3Close");		
		if (ObjectFind("B3CCI") != -1) ObjectDelete("B3CCI");
		if (ObjectFind("B3CCIm5L") != -1) ObjectDelete("B3CCIm5L");
		if (ObjectFind("B3CCIm5V") != -1) ObjectDelete("B3CCIm5V");
		if (ObjectFind("B3CCIm15L") != -1) ObjectDelete("B3CCIm15L");
		if (ObjectFind("B3CCIm15V") != -1) ObjectDelete("B3CCIm15V");
		if (ObjectFind("B3CCIm30L") != -1) ObjectDelete("B3CCIm30L");
		if (ObjectFind("B3CCIm30V") != -1) ObjectDelete("B3CCIm30V");
		if (ObjectFind("B3CCIh1L") != -1) ObjectDelete("B3CCIh1L");
		if (ObjectFind("B3CCIh1V") != -1) ObjectDelete("B3CCIh1V");
}
//+-----------------------------------------------------------------+
//| Create Object List Function                                     |
//+-----------------------------------------------------------------+

void LabelCreate(){
		if ((displayOverlay && Testing && Visual) || (displayOverlay && !Testing)){
				if (displayLogo){
						ObjectCreate("B3Logo",OBJ_LABEL,0,0,0);
						ObjectSetText("B3Logo","Q",36,"Wingdings",Crimson);
						ObjectSet("B3Logo",OBJPROP_CORNER,3);
						ObjectSet("B3Logo",OBJPROP_XDISTANCE,10);
						ObjectSet("B3Logo",OBJPROP_YDISTANCE,10);
						ObjectCreate("B3CRight",OBJ_LABEL,0,0,0);
						ObjectSetText("B3CRight"," 2010, J Talon LLC/FiFtHeLeMeNt",10,"Arial",Silver);
						ObjectSet("B3CRight",OBJPROP_CORNER,3);
						ObjectSet("B3CRight",OBJPROP_XDISTANCE,5);
						ObjectSet("B3CRight",OBJPROP_YDISTANCE,3);
				}
				else {
						if (ObjectFind("B3Logo") != -1) ObjectDelete("B3Logo");
						if (ObjectFind("B3CRight") != -1) ObjectDelete("B3CRight");
				}
				ObjectCreate("B3MM",OBJ_LABEL,0,0,0);
				if (UseMM) ObjectSetText("B3MM","Money Management is On",displayFontSize,"Arial Bold",Green);
				else ObjectSetText("B3MM","Money Management is Off",displayFontSize,"Arial Bold",Red);
				ObjectSet("B3MM",OBJPROP_CORNER,0);
				ObjectSet("B3MM",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3MM",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*7)));
				ObjectCreate("B3LTime",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LTime","Current Time is:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LTime",OBJPROP_CORNER,0);
				ObjectSet("B3LTime",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LTime",OBJPROP_YDISTANCE,(displayYcord));
				ObjectCreate("B3LEP",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LEP","Equity Protection % Set:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LEP",OBJPROP_CORNER,0);
				ObjectSet("B3LEP",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LEP",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*2)));
				ObjectCreate("B3POSL",OBJ_LABEL,0,0,0);
				if (UsePowerOutSL) ObjectSetText("B3POSL","Power Off Stop Loss is On",displayFontSize,"Arial Bold",Green);
				else ObjectSetText("B3POSL","Power Off Stop Loss is Off",displayFontSize,"Arial Bold",Red);
				ObjectSet("B3POSL",OBJPROP_CORNER,0);
				ObjectSet("B3POSL",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3POSL",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*8)));
				ObjectCreate("B3LLotSize",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LLotSize","Starting Lot Size:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LLotSize",OBJPROP_CORNER,0);
				ObjectSet("B3LLotSize",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LLotSize",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*10)));
				ObjectCreate("B3LProfitPot",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LProfitPot","Profit Potential:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LProfitPot",OBJPROP_CORNER,0);
				ObjectSet("B3LProfitPot",OBJPROP_XDISTANCE,(displayXcord+30));
				ObjectSet("B3LProfitPot",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*12)));
				ObjectCreate("B3LProfitSL",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LProfitSL","Profit Trailing Stop:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LProfitSL",OBJPROP_CORNER,0);
				ObjectSet("B3LProfitSL",OBJPROP_XDISTANCE,(displayXcord+30));
				ObjectSet("B3LProfitSL",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*13)));
				ObjectCreate("B3Trend",OBJ_LABEL,0,0,0);
				ObjectSet("B3Trend",OBJPROP_CORNER,0);
				ObjectSet("B3Trend",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3Trend",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*20)));
				ObjectCreate("B3LBuy",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LBuy","Buy Count:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LBuy",OBJPROP_CORNER,0);
				ObjectSet("B3LBuy",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LBuy",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*17)));
				ObjectCreate("B3LSell",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LSell","Sell Count:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LSell",OBJPROP_CORNER,0);
				ObjectSet("B3LSell",OBJPROP_XDISTANCE,(displayXcord+150));
				ObjectSet("B3LSell",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*17)));
				ObjectCreate("B3LCurrentTP",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LCurrentTP","Current TP:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LCurrentTP",OBJPROP_CORNER,0);
				ObjectSet("B3LCurrentTP",OBJPROP_XDISTANCE,(displayXcord+30));
				ObjectSet("B3LCurrentTP",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*15)));
				ObjectCreate("B3LMoveTP",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LMoveTP","Move TP by:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LMoveTP",OBJPROP_CORNER,0);
				ObjectSet("B3LMoveTP",OBJPROP_XDISTANCE,(displayXcord+30));
				ObjectSet("B3LMoveTP",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*16)));
				ObjectCreate("B3LMoves",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LMoves","# Moves:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LMoves",OBJPROP_CORNER,0);
				ObjectSet("B3LMoves",OBJPROP_XDISTANCE,(displayXcord+190));
				ObjectSet("B3LMoves",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*16)));
				ObjectCreate("B3LPortion",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LPortion","Account Portion:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LPortion",OBJPROP_CORNER,0);
				ObjectSet("B3LPortion",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LPortion",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*5)));
				ObjectCreate("B3LPCRisked",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LPCRisked","Account % Risked:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LPCRisked",OBJPROP_CORNER,0);
				ObjectSet("B3LPCRisked",OBJPROP_XDISTANCE,(displayXcord+210));
				ObjectSet("B3LPCRisked",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*6)));
				ObjectCreate("B3LBalance",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LBalance","Portion Balance:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LBalance",OBJPROP_CORNER,0);
				ObjectSet("B3LBalance",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LBalance",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*6)));
				ObjectCreate("B3LStopTrade",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LStopTrade","Stop Trade Amount:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LStopTrade",OBJPROP_CORNER,0);
				ObjectSet("B3LStopTrade",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LStopTrade",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*4)));
				ObjectCreate("B3LMaxDD",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LMaxDD","Max DD:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LMaxDD",OBJPROP_CORNER,0);
				ObjectSet("B3LMaxDD",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LMaxDD",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*18)));
				ObjectCreate("B3LPortionPL",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LPortionPL","Portion P/L:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LPortionPL",OBJPROP_CORNER,0);
				ObjectSet("B3LPortionPL",OBJPROP_XDISTANCE,(displayXcord+30));
				ObjectSet("B3LPortionPL",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*14)));
				ObjectCreate("B3LMaxDDPC",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LMaxDDPC","Max DD %:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LMaxDDPC",OBJPROP_CORNER,0);
				ObjectSet("B3LMaxDDPC",OBJPROP_XDISTANCE,(displayXcord+150));
				ObjectSet("B3LMaxDDPC",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*18)));
				ObjectCreate("B3VProfit",OBJ_LABEL,0,0,0);
				ObjectSet("B3VProfit",OBJPROP_CORNER,0);
				ObjectSet("B3VProfit",OBJPROP_XDISTANCE,(displayXcord+190));
				ObjectSet("B3VProfit",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*14)));
				ObjectCreate("B3LStopTradePC",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LStopTradePC","Stop Trade % Set:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LStopTradePC",OBJPROP_CORNER,0);
				ObjectSet("B3LStopTradePC",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LStopTradePC",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*3)));
				ObjectCreate("B3Line1",OBJ_LABEL,0,0,0);
				ObjectSetText("B3Line1","=========================",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3Line1",OBJPROP_CORNER,0);
				ObjectSet("B3Line1",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3Line1",OBJPROP_YDISTANCE,(displayYcord+displaySpacing));
				ObjectCreate("B3VStopTradePC",OBJ_LABEL,0,0,0);
				ObjectSet("B3VStopTradePC",OBJPROP_CORNER,0);
				ObjectSet("B3VStopTradePC",OBJPROP_XDISTANCE,(displayXcord+200));
				ObjectSet("B3VStopTradePC",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*3)));
				ObjectCreate("B3VTime",OBJ_LABEL,0,0,0);
				ObjectSet("B3VTime",OBJPROP_CORNER,0);
				ObjectSet("B3VTime",OBJPROP_XDISTANCE,(displayXcord+125));
				ObjectSet("B3VTime",OBJPROP_YDISTANCE,(displayYcord));
				ObjectCreate("B3VMaxDDPC",OBJ_LABEL,0,0,0);
				ObjectSet("B3VMaxDDPC",OBJPROP_CORNER,0);
				ObjectSet("B3VMaxDDPC",OBJPROP_XDISTANCE,(displayXcord+200));
				ObjectSet("B3VMaxDDPC",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*2)));
				ObjectCreate("B3VLotSize",OBJ_LABEL,0,0,0);
				ObjectSet("B3VLotSize",OBJPROP_CORNER,0);
				ObjectSet("B3VLotSize",OBJPROP_XDISTANCE,(displayXcord+140));
				ObjectSet("B3VLotSize",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*10)));
				ObjectCreate("B3VProfitPot",OBJ_LABEL,0,0,0);
				ObjectSet("B3VProfitPot",OBJPROP_CORNER,0);
				ObjectSet("B3VProfitPot",OBJPROP_XDISTANCE,(displayXcord+190));
				ObjectSet("B3VProfitPot",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*12)));
				ObjectCreate("B3VProfitSL",OBJ_LABEL,0,0,0);
				ObjectSet("B3VProfitSL",OBJPROP_CORNER,0);
				ObjectSet("B3VProfitSL",OBJPROP_XDISTANCE,(displayXcord+190));
				ObjectSet("B3VProfitSL",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*13)));
				ObjectCreate("B3VBuy",OBJ_LABEL,0,0,0);
				ObjectSet("B3VBuy",OBJPROP_CORNER,0);
				ObjectSet("B3VBuy",OBJPROP_XDISTANCE,(displayXcord+100));
				ObjectSet("B3VBuy",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*17)));
				ObjectCreate("B3VSell",OBJ_LABEL,0,0,0);
				ObjectSet("B3VSell",OBJPROP_CORNER,0);
				ObjectSet("B3VSell",OBJPROP_XDISTANCE,(displayXcord+240));
				ObjectSet("B3VSell",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*17)));
				ObjectCreate("B3VCurrentTP",OBJ_LABEL,0,0,0);
				ObjectSet("B3VCurrentTP",OBJPROP_CORNER,0);
				ObjectSet("B3VCurrentTP",OBJPROP_XDISTANCE,(displayXcord+190));
				ObjectSet("B3VCurrentTP",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*15)));
				ObjectCreate("B3VMoveTP",OBJ_LABEL,0,0,0);
				ObjectSet("B3VMoveTP",OBJPROP_CORNER,0);
				ObjectSet("B3VMoveTP",OBJPROP_XDISTANCE,(displayXcord+140));
				ObjectSet("B3VMoveTP",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*16)));
				ObjectCreate("B3VMoves",OBJ_LABEL,0,0,0);
				ObjectSet("B3VMoves",OBJPROP_CORNER,0);
				ObjectSet("B3VMoves",OBJPROP_XDISTANCE,(displayXcord+270));
				ObjectSet("B3VMoves",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*16)));
				ObjectCreate("B3VPortion",OBJ_LABEL,0,0,0);
				ObjectSet("B3VPortion",OBJPROP_CORNER,0);
				ObjectSet("B3VPortion",OBJPROP_XDISTANCE,(displayXcord+150));
				ObjectSet("B3VPortion",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*5)));
				ObjectCreate("B3VPCRisked",OBJ_LABEL,0,0,0);
				ObjectSet("B3VPCRisked",OBJPROP_CORNER,0);
				ObjectSet("B3VPCRisked",OBJPROP_XDISTANCE,(displayXcord+350));
				ObjectSet("B3VPCRisked",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*6)));
				ObjectCreate("B3VLEPRisked",OBJ_LABEL,0,0,0);
				ObjectSet("B3VLEPRisked",OBJPROP_CORNER,0);
				ObjectSet("B3VLEPRisked",OBJPROP_XDISTANCE,(displayXcord+200));
				ObjectSet("B3VLEPRisked",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*2)));
				ObjectCreate("B3VPortionPL",OBJ_LABEL,0,0,0);
				ObjectSet("B3VPortionPL",OBJPROP_CORNER,0);
				ObjectSet("B3VPortionPL",OBJPROP_XDISTANCE,(displayXcord+150));
				ObjectSet("B3VPortionPL",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*6)));
				ObjectCreate("B3VStopTrade",OBJ_LABEL,0,0,0);
				ObjectSet("B3VStopTrade",OBJPROP_CORNER,0);
				ObjectSet("B3VStopTrade",OBJPROP_XDISTANCE,(displayXcord+200));
				ObjectSet("B3VStopTrade",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*4)));
				ObjectCreate("B3VMaxDD",OBJ_LABEL,0,0,0);
				ObjectSet("B3VMaxDD",OBJPROP_CORNER,0);
				ObjectSet("B3VMaxDD",OBJPROP_XDISTANCE,(displayXcord+100));
				ObjectSet("B3VMaxDD",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*18)));
				ObjectCreate("B3VMaxDDPC",OBJ_LABEL,0,0,0);
				ObjectSet("B3VMaxDDPC",OBJPROP_CORNER,0);
				ObjectSet("B3VMaxDDPC",OBJPROP_XDISTANCE,(displayXcord+240));
				ObjectSet("B3VMaxDDPC",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*18)));
				ObjectCreate("B3Line2",OBJ_LABEL,0,0,0);
				ObjectSetText("B3Line2","======================",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3Line2",OBJPROP_CORNER,0);
				ObjectSet("B3Line2",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3Line2",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*9)));
				ObjectCreate("B3LPrMax",OBJ_LABEL,0,0,0);
				if (MaximizeProfit) ObjectSetText("B3LPrMax","Profit Maximizer is On",displayFontSize,"Arial Bold",Green);
				else ObjectSetText("B3LPrMax","Profit Maximizer is Off",displayFontSize,"Arial Bold",Red);
				ObjectSet("B3LPrMax",OBJPROP_CORNER,0);
				ObjectSet("B3LPrMax",OBJPROP_XDISTANCE,(displayXcord));
				ObjectSet("B3LPrMax",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*11)));
				ObjectCreate("B3Slash",OBJ_LABEL,0,0,0);
				ObjectSetText("B3Slash","/",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3Slash",OBJPROP_CORNER,0);
				ObjectSet("B3Slash",OBJPROP_XDISTANCE,(displayXcord+283));
				ObjectSet("B3Slash",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*16)));
				ObjectCreate("B3VTotalMoves",OBJ_LABEL,0,0,0);
				ObjectSet("B3VTotalMoves",OBJPROP_CORNER,0);
				ObjectSet("B3VTotalMoves",OBJPROP_XDISTANCE,(displayXcord+290));
				ObjectSet("B3VTotalMoves",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*16)));
				ObjectCreate("B3LLots",OBJ_LABEL,0,0,0);
				ObjectSetText("B3LLots","Total Lots:",displayFontSize,"Arial Bold",displayColor);
				ObjectSet("B3LLots",OBJPROP_CORNER,0);
				ObjectSet("B3LLots",OBJPROP_XDISTANCE,(displayXcord+190));
				ObjectSet("B3LLots",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*10)));
				ObjectCreate("B3VLots",OBJ_LABEL,0,0,0);
				ObjectSet("B3VLots",OBJPROP_CORNER,0);
				ObjectSet("B3VLots",OBJPROP_XDISTANCE,(displayXcord+275));
				ObjectSet("B3VLots",OBJPROP_YDISTANCE,(displayYcord+(displaySpacing*10)));
				if (CCIEntry){
						ObjectCreate("B3CCI",OBJ_LABEL,0,0,0);
						ObjectSetText("B3CCI","CCI",displayFontSize + 2,"Arial Bold",displayColor);
						ObjectSet("B3CCI",OBJPROP_CORNER,1);
						ObjectSet("B3CCI",OBJPROP_XDISTANCE,displayCCIxCord+12);
						ObjectSet("B3CCI",OBJPROP_YDISTANCE,displayYcord);
						ObjectCreate("B3CCIm5L",OBJ_LABEL,0,0,0);
						ObjectSetText("B3CCIm5L","m5",displayFontSize + 2,"Arial Bold",displayColor);
						ObjectSet("B3CCIm5L",OBJPROP_CORNER,1);
						ObjectSet("B3CCIm5L",OBJPROP_XDISTANCE,displayCCIxCord+25);
						ObjectSet("B3CCIm5L",OBJPROP_YDISTANCE,displayYcord+displaySpacing*1.2);
						ObjectCreate("B3CCIm5V",OBJ_LABEL,0,0,0);
						ObjectSet("B3CCIm5V",OBJPROP_CORNER,1);
						ObjectSet("B3CCIm5V",OBJPROP_XDISTANCE,displayCCIxCord);
						ObjectSet("B3CCIm5V",OBJPROP_YDISTANCE,displayYcord+displaySpacing*1);
						ObjectCreate("B3CCIm15L",OBJ_LABEL,0,0,0);
						ObjectSetText("B3CCIm15L","m15",displayFontSize + 2,"Arial Bold",displayColor);
						ObjectSet("B3CCIm15L",OBJPROP_CORNER,1);
						ObjectSet("B3CCIm15L",OBJPROP_XDISTANCE,displayCCIxCord+25);
						ObjectSet("B3CCIm15L",OBJPROP_YDISTANCE,displayYcord+displaySpacing*2.4);
						ObjectCreate("B3CCIm15V",OBJ_LABEL,0,0,0);
						ObjectSet("B3CCIm15V",OBJPROP_CORNER,1);
						ObjectSet("B3CCIm15V",OBJPROP_XDISTANCE,displayCCIxCord);
						ObjectSet("B3CCIm15V",OBJPROP_YDISTANCE,displayYcord+displaySpacing*2.2);
						ObjectCreate("B3CCIm30L",OBJ_LABEL,0,0,0);
						ObjectSetText("B3CCIm30L","m30",displayFontSize + 2,"Arial Bold",displayColor);
						ObjectSet("B3CCIm30L",OBJPROP_CORNER,1);
						ObjectSet("B3CCIm30L",OBJPROP_XDISTANCE,displayCCIxCord+25);
						ObjectSet("B3CCIm30L",OBJPROP_YDISTANCE,displayYcord+displaySpacing*3.6);
						ObjectCreate("B3CCIm30V",OBJ_LABEL,0,0,0);
						ObjectSet("B3CCIm30V",OBJPROP_CORNER,1);
						ObjectSet("B3CCIm30V",OBJPROP_XDISTANCE,displayCCIxCord);
						ObjectSet("B3CCIm30V",OBJPROP_YDISTANCE,displayYcord+displaySpacing*3.4);
						ObjectCreate("B3CCIh1L",OBJ_LABEL,0,0,0);
						ObjectSetText("B3CCIh1L","h1",displayFontSize + 2,"Arial Bold",displayColor);
						ObjectSet("B3CCIh1L",OBJPROP_CORNER,1);
						ObjectSet("B3CCIh1L",OBJPROP_XDISTANCE,displayCCIxCord+25);
						ObjectSet("B3CCIh1L",OBJPROP_YDISTANCE,displayYcord+displaySpacing*4.8);
						ObjectCreate("B3CCIh1V",OBJ_LABEL,0,0,0);
						ObjectSet("B3CCIh1V",OBJPROP_CORNER,1);
						ObjectSet("B3CCIh1V",OBJPROP_XDISTANCE,displayCCIxCord);
						ObjectSet("B3CCIh1V",OBJPROP_YDISTANCE,displayYcord+displaySpacing*4.6);
				}
		}
		return;
}

//+-----------------------------------------------------------------+
//| expert end function                                             |
//+-----------------------------------------------------------------+